import zlib
import sys,binascii,re,struct,base64,textwrap,pprint,xml.dom.minidom,re,glob,os,datetime,time,random
from xml.dom.minidom import Node

replacetable=[
[chr(0),''  ,''],
[chr(1),' ' ,'free'],
[chr(2),'#' ,'solid'],
[chr(3),'.' ,'grass'],
[chr(4),'O' ,'boulder'],
[chr(5),'*' ,'diamond'],
[chr(6),'F' ,'firefly'],
[chr(7),'B' ,'butterfly'],
[chr(8),'E' ,'entry'],
[chr(9),'X' ,'exit'],
[chr(10),'=','wall']
]
def checkmap(map):
	cnt={}
	for c in map:
		cnt[c] = cnt.get(c,0)+1
	print cnt
	for c in range(0,len(replacetable)-1):
		if(cnt.has_key(replacetable[c][1])): print "(",replacetable[c][1],")","x",cnt[replacetable[c][1]],"  (",replacetable[c][2],")"
	
	if(cnt.has_key('E')):
		if(cnt['E']<4): print "WARNING!!!!! THERE ARE LESS THAN 4 ENTRYS!"
	else: print "WARNING!!!!! THERE ARE LESS THAN 4 ENTRYS!"
	
	if(cnt.has_key('X')):
		if(cnt['X']<=0): print "WARNING!!!!! THERE IS NO EXIT!"
	else: print "WARNING!!!!! THERE IS NO EXIT!"
	
	if(cnt.has_key('*')):
		if(cnt['*']<=0): print "WARNING!!!!! THERE ARE NO DIAMONDS!"
	else: print "WARNING!!!!! THERE ARE NO DIAMONDS!"

def tmx2lev(inputfile,outputfile):
	doc = xml.dom.minidom.parse(inputfile)
	for node in doc.getElementsByTagName("map"):
		width = node.getAttribute("width")
		height = node.getAttribute("height")
	for node in doc.getElementsByTagName("layer"):
		settings = node.getAttribute("name")
	
	
	settings=settings.replace(';','\n');
	
	L = node.getElementsByTagName("data")
	for node2 in L:
		data=""
		for node3 in node2.childNodes:
			if node3.nodeType == Node.TEXT_NODE:
				data += node3.data
	#print "Width:", width
	#print "Height:", height
	#print "Base64Data:",data


	#file = open('test.64', 'r').read()
	#print 'Filedata :',file
	basedecoded=base64.b64decode(data)
	#DEBUGfiledebug = open('debug.base64decoded', 'w')
	#DEBUGfiledebug.write(basedecoded)
	#DEBUGfiledebug.close()

	decompressed = zlib.decompress(basedecoded)
	#DEBUGfiledebug = open('debug.decompressed', 'w')
	#DEBUGfiledebug.write(decompressed)
	#DEBUGfiledebug.close()

	map=decompressed
	#map=map.replace("\00", '')
	for i in range(0, len(replacetable)):
		map=map.replace(replacetable[i][0], replacetable[i][1])
	checkmap(map)
		#print i
	#tw=textwrap.wrap(map,25)
	#print map
	#tw="\r".join(textwrap.wrap(map,int(width)))
	tw=""
	for i in range(0,len(map)):
		if(i%int(width)==0 and i!=0): tw=tw+'\n'
		tw=tw+map[i]
	#tw2=textwrap.wrap(tw,int(width))
	
	file2 = open(outputfile, 'wt')
	#file2.write('diamonds=1\n')
	file2.write(settings)
	file2.write('\n')
	file2.write('level=\n')
	file2.write(tw)
	file2.write('\n')
	file2.close()
	#print map
	#print 'finished'

def lev2tmx(inputfile,outputfile):
	###encodepart
	#print '###DECODE###'
	file = open('dummyxml.xml', 'r').read()
	file2 = open(inputfile, 'r').read()
	data=file2
	
	#if found, replace \r\n   to   \r
	data=data.replace('\r\n','\n');
	
	#convert back to array
	data=data.split(chr(10))
	DIAMNUM=data[0].replace('diamonds=','')
	newmap=''
	for i in range(2, len(data)):
		newmap=newmap+data[i]
	#print newmap
	
	#######CHECK MAP
	checkmap(newmap)
	
	for i in range(1, len(replacetable)):
		newmap=newmap.replace(replacetable[i][1], replacetable[i][0]+chr(0)+chr(0)+chr(0))
	
	#DEBUGfiledebug = open('debug2.replaced', 'w')
	#DEBUGfiledebug.write(newmap)
	#DEBUGfiledebug.close()	
	
	
	compressed = zlib.compress(newmap)

	#DEBUGfiledebug = open('debug2.compressed', 'w')
	#DEBUGfiledebug.write(newmap)
	#DEBUGfiledebug.close()	

	base64encode=base64.b64encode(compressed)

	#DEBUGfiledebug = open('debug2.encoded', 'w')
	#DEBUGfiledebug.write(base64encode)
	#DEBUGfiledebug.close()	

	#print newmap
	#DEBUGfile3 = open('encode.dat', 'w')
	#DEBUGfile3.write(base64encode)
	#DEBUGfile3.close()
	mapwidth=len(data[2])
	mapheight=len(data)-2
	if (data[(mapheight+1)]==''): mapheight=mapheight-1 #fix height, if the last line of the txt-map is empty

	#print "NewMapWidth:",mapwidth
	#print "NewMapHeight:", mapheight
	newxmlfile=file
	newxmlfile=newxmlfile.replace('WIDTHVALUE',str(mapwidth))
	newxmlfile=newxmlfile.replace('HEIGHTVALUE',str(mapheight))
	newxmlfile=newxmlfile.replace('BASE64DATA',base64encode)
	newxmlfile=newxmlfile.replace('DIAMNUM',DIAMNUM)
	#print newxmlfile
	outputfilename=inputfile.split('.');
	
	file4 = open(outputfile, 'w')
	file4.write(newxmlfile)
	file4.close()
	#print 'finished'

def generate_empty_map(MAP_WIDTH,MAP_HEIGHT,diamonds):
	print 'Generating empty map '+str(MAP_WIDTH)+'x'+str(MAP_HEIGHT)
	map=""
	maparray=[['' for col in range(MAP_WIDTH)] for row in range(MAP_HEIGHT)]
	for y in range (0,MAP_HEIGHT):
		for x in range(0,MAP_WIDTH):
			if ( (x>0) and (x<MAP_WIDTH) and (y<MAP_HEIGHT) ): maparray[y][x]='.'
			if (y==0): maparray[y][x]='#' #upper wall
			if (x==0): maparray[y][x]='#' #left wall
			if (y==MAP_HEIGHT-1): maparray[y][x]='#' #lower wall
			if (x==MAP_WIDTH-1): maparray[y][x]='#' #right wall
	#print maparray
		
	for i in range (0,diamonds):
		a=random.randint(1,MAP_HEIGHT-2)
		b=random.randint(1,MAP_WIDTH-2)
		#if there is already a diamond, get new random coordinates xy until...
		while(maparray[a][b]=='*'):
			a=random.randint(1,MAP_HEIGHT-2)
			b=random.randint(1,MAP_WIDTH-2)
		#put random_diamond
		maparray[a][b]='*' 
	for y in range (0,MAP_HEIGHT):
		for x in range(0,MAP_WIDTH):
			map+=maparray[y][x]
		map+='\n'
	
	output="diamonds="
	output+=str(diamonds)
	output+="\n"
	output+="level=\n"	
	output+=map
	print output
	file4 = open("empty.lev", 'w')
	file4.write(output)
	file4.close()
	
	
	
	
#for arg in sys.argv:
 #   print arg

#tmx2lev(in,out)
#lev2tmx(in,out)
print 'DoubleDash MapConverter/Generator v1.0 by BlackWhiteEagle'
print ''
print 'Usage:\n'
print 'convert between map-formats:'
print 'ddashconvert lev2tmx/*.lev'
print 'ddashconvert tmx2lev/*.tmx'
print 'ddashconvert d file.tmx newfile.lev'
print 'ddashconvert e file.lev newfile.tmx'
print '\r'
print 'Generate a map <WIDTH>x<HEIGHT> with DIAMONDS:\n'
print 'ddashconvert generate <WIDTH> <HEIGHT> <DIAMONDS>'
print ''

if (len(sys.argv)<=1): exit()

if(sys.argv[1]=='d'): tmx2lev(sys.argv[2],outputfile)
if(sys.argv[1]=='e'): lev2tmx(sys.argv[2],outputfile)

if(sys.argv[1]=='tmx2lev'):
	dateilistetmx=glob.glob('*.tmx')
	t=datetime.datetime.now()
	num=time.mktime(t.timetuple())
	os.mkdir('mappack-'+str(num))
	
	for i in range(0, len(dateilistetmx)):
		inputfilename=dateilistetmx[i]
		newfilename='mappack-'+str(num)+'/level'+str(i+1)+'.lev'
		print 'Convert '+inputfilename+' to '+newfilename+'.'
		tmx2lev(inputfilename,newfilename)

if(sys.argv[1]=='lev2tmx'):
	dateilistetmx=glob.glob('*.lev')
	for i in range(0, len(dateilistetmx)):
		inputfilename=dateilistetmx[i]
		newfilename='ConvertedTiledMap'+str(i+1)+'.tmx'
		print 'Convert '+inputfilename+' to '+newfilename+'.'
		lev2tmx(inputfilename,newfilename)

if(sys.argv[1]=='generate'):
	border=(int(sys.argv[2])+int(sys.argv[3])+(int(sys.argv[2])-2)+(int(sys.argv[3])-2))
	maxdiamonds=int(sys.argv[2])*int(sys.argv[3])-border
	if(int(sys.argv[4])>maxdiamonds): 
		print sys.argv[4]+' diamonds are too much, maximum for this map is '+str(maxdiamonds)+'. aborting...'
		exit()	
	generate_empty_map(int(sys.argv[2]),int(sys.argv[3]),int(sys.argv[4]))
	lev2tmx("empty.lev","empty.tmx")